#### connect (5 of 12 overloads)

Establishes a socket connection by trying each endpoint in a sequence.

    template<
        typename Protocol,
        typename Executor,
        typename Iterator>
    Iterator connect(
        basic_socket< Protocol, Executor > & s,
        Iterator begin,
        Iterator end);

This function attempts to connect a socket to one of a sequence of endpoints. It does this by repeated calls to the socket's `connect` member function, once for each endpoint in the sequence, until a connection is successfully established.

###### Parameters

s

  The socket to be connected. If the socket is already open, it will be closed.

begin

  An iterator pointing to the start of a sequence of endpoints.

end

  An iterator pointing to the end of a sequence of endpoints.

###### Return Value

An iterator denoting the successfully connected endpoint.

###### Exceptions

asio::system_error

  Thrown on failure. If the sequence is empty, the associated `error_code` is `asio::error::not_found`. Otherwise, contains the error from the last connection attempt.

###### Example

    tcp::resolver r(my_context);
    tcp::resolver::query q("host", "service");
    tcp::resolver::results_type e = r.resolve(q);
    tcp::socket s(my_context);
    asio::connect(s, e.begin(), e.end());